import kotlinx.coroutines.*
import java.util.concurrent.Executors

fun main() {
  val executorDispatcher = Executors
      .newWorkStealingPool()
      .asCoroutineDispatcher()

  val coroutineErrorHandler = CoroutineExceptionHandler { coroutineContext, throwable ->
    throwable.printStackTrace() // we just print the error here
  }

  val emptyParentJob = Job()

  val combinedContext = executorDispatcher + coroutineErrorHandler + emptyParentJob

  GlobalScope.launch(context = combinedContext) {
    println(Thread.currentThread().name)
  }


  Thread.sleep(50)
}