import kotlinx.coroutines.cancelAndJoin
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import kotlinx.coroutines.runBlocking

fun main() = runBlocking {
  val job = launch {
    val childJob = launch {
      try {
        delay(Long.MAX_VALUE)
        println("childJob is canceled")
      } catch (e: Exception) {
        println("childJob has an exception: " +
            "${e.message}\n" +
            "  | ${e.javaClass.simpleName}")
      } finally {
        println("Inside finally of childJob")
      }
    }
    println("Cancelling child")
    childJob.cancelAndJoin()

    println("Parent is not canceled")
  }
  job.join()
}